#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <fstream>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>

using namespace std;

const int md = 1000000007;

inline void add(int &a, int b) {
	a += b;
	if (a >= md) {
		a -= md;
	}
}

inline int mul(int a, int b) {
	return (long long)a * b % md;
}

const int N = 3010;

int outer[N][N], inner[N][N];

int solve(string s) {
	int n = s.length();
	for (int i = 0; i < n; i++) {
		for (int j = i; j < n; j++) {
			outer[i][j] = 0;
		}
	}
	outer[0][max(0, n - 1)] = 1;
	for (int i = 0; i < n; i++) {
		for (int j = n - 1; j >= i; j--) {
			int ft = outer[i][j];
			if (ft == 0) {
				continue;
			}
			if (i < j) {
				add(outer[i + 1][j], ft);
				add(outer[i][j - 1], ft);
			}
			if (i + 1 <= j - 1) {
				add(outer[i + 1][j - 1], md - ft);
			}
			if (i + 1 <= j - 1 && s[i] == s[j]) {
				add(outer[i + 1][j - 1], ft);
			}
		}
	}
	for (int i = n - 1; i >= 0; i--) {
		for (int j = i; j < n; j++) {
			inner[i][j] = 0;
			if (i < j) {
				add(inner[i][j], inner[i + 1][j]);
				add(inner[i][j], inner[i][j - 1]);
			}
			else {
				add(inner[i][j], 2);
			}
			if (i + 1 <= j - 1) {
				add(inner[i][j], md - inner[i + 1][j - 1]);
			}
			else {
				add(inner[i][j], md - 1);
			}
			if (s[i] == s[j]) {
				if (i + 1 <= j - 1) {
					add(inner[i][j], inner[i + 1][j - 1]);
				}
				else {
					add(inner[i][j], 1);
				}
			}
		}
	}
	int ans = 0;
	for (int i = 0; i < n; i++) {
		int X = 0;
		for (int j = 0; j < n; j++) {
			if (s[i] != s[j]) {
				continue;
			}
			int a = i, b = j;
			if (a > b) {
				swap(a, b);
			}
			if (a == b || a + 1 == b) {
				add(X, outer[a][b]);
				continue;
			}
			add(X, mul(outer[a][b], inner[a + 1][b - 1]));
		}
		ans ^= mul(i + 1, X);
	}
	return ans;
}

void solve_test(istream &fin, ostream &fout)
{
	int n;
	fin >> n;
	string s;
	fin >> s;
	n = solve(s);
	fout << n << '\n';
}

int main(int argc, char* argv[])
{
	if (argc>1 && (string)argv[1] == "all")
	{
		for (int i = 0; i <= 53; ++i)
		{
			ifstream  fin("input" + to_string(i) + ".txt");
			ofstream fout("output" + to_string(i) + ".txt");
			clock_t start = clock();
			solve_test(fin, fout);
			clock_t stop = clock();
			cout << i << ' ' << (float)(stop - start) / CLOCKS_PER_SEC << '\n';
			fout.close();
		}
	}
	else
	{
		ifstream fin("palisis.txt");
		ofstream fout("palival.txt");
		solve_test(fin, fout);
	}

	return 0;
}
