#pragma comment(linker, "/STACK:66777216")
#include <algorithm>
#include <cassert>
#include <cmath>
#include <deque>
#include <iostream>
#include <iomanip>
#include <iterator>
#include <fstream>
#include <queue>
#include <map>
#include <set>
#include <string>
#include <vector>

using namespace std;

typedef long long ll;

const int maxN = 1000005;

const int INF = 1000000000;

struct component {
	int countEdge;
	int countVertex;
	component() {
		countEdge = countVertex = 0;
	}
	component(int _countEdge, int _countVertex) {
		countEdge = _countEdge, countVertex = _countVertex;
	}
};

component a[maxN];

vector<int> g[maxN];

bool used[maxN];

int b[maxN], cntE, cntV;

void dfs(int v) {
	used[v] = false;
	++cntV;
	for (int i = 0; i < g[v].size(); ++i) {
		int next = g[v][i];
		++cntE;
		if (used[next] == false) continue;
		dfs(next);
	}
}

ll getSizeComp(int s) {
	ll ret = (ll) s;
	return ret * (ret - 1) / 2;
}

void solveTask() {
	int n, m, K;
	scanf("%d %d %d\n", &n, &m, &K);
	ll k = K;
	for (int i = 1; i <= m; ++i) {
		int l, r;
		scanf("%d %d\n", &l, &r);
		g[l].push_back(r);
		g[r].push_back(l);
	}
	for (int i = 1; i <= n; ++i) used[i] = true;
	int cntComp = 0;
	for (int i = 1; i <= n; ++i) {
		if (!used[i]) continue;
		cntE = cntV = 0;
		dfs(i);
		assert(cntE % 2 == 0);
		++cntComp;
		a[cntComp] = component(cntE / 2, cntV);
	}
	int answerMin = max((int)1, cntComp - K);
	int answerMax = INF;
	for (int i = 1; i <= cntComp; ++i) {
		ll s = (ll)a[i].countVertex;
		s = s * (s - 1) / 2;
		ll p = s - (ll)a[i].countEdge;
		k -= p;
	}
	k = max((ll)0, k);
	for (int i = 1; i <= cntComp; ++i) b[i] = a[i].countVertex;
	sort(b + 1, b + cntComp + 1);
	reverse(b + 1, b + cntComp + 1);
	ll cntVertex = 0, cntEdges = 0;
	for (int i = 1; i <= cntComp; ++i) {
		cntVertex += (ll)b[i];
		cntEdges += getSizeComp(b[i]);
		ll currentCountEdges = cntVertex * (cntVertex - 1) / 2;
		if (currentCountEdges - cntEdges >= k) {
	  	answerMax = 1 + (cntComp - i);
	  	break;
		}
	}
	printf("%d %d\n", answerMin, answerMax);
}

int main() {
	freopen("teedsis.txt", "r", stdin);
	freopen("teedval.txt", "w", stdout);
	solveTask();
	return 0;
}
