#include <fstream>
#include <iostream>
#include <cstdlib>
using namespace std;

void done(int n) {
	cout << n << "\n";
	exit(0);
}

int n, m, k;
int *a;

void input(const char *file) {
	ifstream f(file);
	if (!f) {
		cerr << "Can't open input file " << file << "\n";
		done(0);
	}
	f >> n >> m >> k;
	if (!f) {
		cerr << "Can't read input file " << file << "\n";
		done(0);
	}
	a = new int[n];
	for (int i = 0; i < n; ++i) {
		f >> a[i];
		if (!f) {
			cerr << "Can't read input file " << file << "\n";
			done(0);
		}
	}
}

double output(const char *file, const char *type) {
	ifstream f(file);
	if (!f) {
		cerr << "Can't open " << type << " file " << file << "\n";
		done(0);
	}
	double ss = 1e9;
	int t = 0, p = 0, b;
	while (f >> b) {
		if (b < m || p + b > n) {
			cerr << "Invalid team size in " << type << " file " << file << "\n";
			done(0);
		}
		++t;
		double s = 0;
		for (int j = 0; j < b; ++j) {
			s += a[p];
			++p;
		}
		if (ss > s / b) {
			ss = s / b;
		}
	}
	if (t != k) {
		cerr << "Invalid number of teams in " << type << " file " << file << "\n";
		done(0);
	}
	if (p != n) {
		cerr << "Invalid number of players in " << type << " file " << file << "\n";
		done(0);
	}
	return ss;
}

int main(int argc, const char *argv[]) {
	if (argc != 4) {
		cerr << "Usage: " << argv[0] << "input hint output\n";
		done(0);
	}

	input(argv[1]);
	double s1 = output(argv[2], "hint");
	double s2 = output(argv[3], "output");

	if (s2 < s1 - .5 / n) {
		cerr << "Suboptimal team strength " << s2 << ", should be " << s1 << "\n";
		done(0);
	}
	if (s2 > s1 + .5 / n) {
		cerr << "ALERT: Superoptimal team strength " << s2 << ", should be " << s1 << "\n";
		done(1);
	}

	cerr << "OK\n";
	done(1);
}
